#include "ClapTrap.hpp"
#include "ScavTrap.hpp"

int main(void) {
	std::cout << "\n";
	ScavTrap none;
	ScavTrap clapy("Clapy");
	ClapTrap clapo("Clapo");

	std::cout << "\n----------------------------\n" << std::endl;

	none.attack("Clapy");
	none.takeDamage(100);
	none.attack("Clapy");
	none.beRepaired(10);

	std::cout << "\n----------------------------\n" << std::endl;

	{
		clapy.attack("Clapo");
		clapo.takeDamage(0);
		clapy.takeDamage(50);
		clapy.beRepaired(5);
		clapy.takeDamage(50);

		for (int i = 0; i < 50; i++)
			clapy.attack("Clapo");
	}

	std::cout << "\n----------------------------\n" << std::endl;

	{
		ScavTrap clapy2(clapy);
		ScavTrap clapy3 = clapy;

		clapy2.attack("Clapo");
		clapy3.attack("Clapo");
	}

	std::cout << "\n----------------------------\n" << std::endl;

	{
		ScavTrap guard("Gigi");

		guard.guardGate();
		guard.takeDamage(100);
		guard.guardGate();
	}

	std::cout << "\n----------------------------\n" << std::endl;

}
