#include "ShrubberyCreationForm.hpp"
#include <fstream>

static const std::string tree = "               ,@@@@@@@,                   \n"
"       ,,,.   ,@@@@@@/@@,  .oo8888o.       \n"
"    ,&\%%&%&&%,@@@@@/@@@@@@,8888\\88/8o      \n"
"   ,%&\\%&&%&&%,@@@\\@@@/@@@88\\88888/88'     \n"
"   %&&%&%&/%&&%@@\\@@/ /@@@88888\\88888'     \n"
"   %&&%/ %&\%%&&@@\\ V /@@' `88\\8 `/88'      \n"
"   `&%\\ ` /%&'    |.|        \\ '|8'        \n"
"       |o|        | |         | |          \n"
"       |.|        | |         | |          \n"
"jgs  \\/ ._\\//_/__/  ,\\_ //__\\/.  \\_//__/_  \n";

ShrubberyCreationAForm::ShrubberyCreationAForm() : AForm("", 145, 137) {}

ShrubberyCreationAForm::ShrubberyCreationAForm(std::string name) : AForm(name, 145, 137) {}

void ShrubberyCreationAForm::executeAction() {
	std::ofstream ofs ((getTarget() + "_shrubbery").c_str());
	ofs << tree;
}
