#include "Base.hpp"

int	main(void) {

	srand(time(NULL));

	std::cout << "\n---Test0---\n" << std::endl;

	int nbr = 5;
	for (int i = 0; i < nbr; i++) {
		Base *base = Base::generate();
		Base::identify(base);
		delete base;
	}

	std::cout << "\n";

	for (int i = 0; i < nbr; i++) {
		Base &base = *Base::generate();
		Base::identify(base);
		delete &base;
	}

	std::cout << "\n---EndTest---\n" << std::endl;

	return (0);
}
