#ifndef CONTACT_HPP
# define CONTACT_HPP

# include <string>

class Contact {
	public:
		Contact();
		Contact(std::string fname, std::string lname, std::string nname, std::string phnbr, std::string drksct);
		Contact& operator=(const Contact& other);

		std::string getFname(void);
		std::string getLname(void);
		std::string getNname(void);
		std::string getPhnbr(void);
		std::string getDrksct(void);
		bool getInit(void);

	private:
		std::string fname;
		std::string lname;
		std::string nname;
		std::string phnbr;
		std::string drksct;
		bool init;
};

#endif
