#include "ClapTrap.hpp"
#include "FragTrap.hpp"

int main(void) {
	std::cout << "\n";
	FragTrap none;
	FragTrap clapy("Clapy");
	ClapTrap clapo("Clapo");

	std::cout << "\n----------------------------\n" << std::endl;

	none.attack("Clapy");
	none.takeDamage(100);
	none.attack("Clapy");
	none.beRepaired(10);

	std::cout << "\n----------------------------\n" << std::endl;

	clapy.attack("Clapo");
	clapo.takeDamage(0);
	clapy.takeDamage(50);
	clapy.beRepaired(5);
	clapy.takeDamage(50);

	for (int i = 0; i < 100; i++)
		clapy.attack("Clapo");

	std::cout << "\n----------------------------\n" << std::endl;

	{
		FragTrap clapy2(clapy);
		FragTrap clapy3 = clapy;

		clapy2.attack("Clapo");
		clapy3.attack("Clapo");
	}

	std::cout << "\n----------------------------\n" << std::endl;

	{
		FragTrap five("Fifi");

		five.highFivesGuys();
		five.takeDamage(100);
		five.highFivesGuys();

		ClapTrap *six = new FragTrap("Fyfy");

		delete six;
	}

	std::cout << "\n----------------------------\n" << std::endl;

}
