#include "Cat.hpp"

Cat::Cat() {
	std::cout << "Cat born" << std::endl;
	this->type = "Cat";
}

Cat::Cat(const Cat &other) : Animal() {
	*this = other;
}

Cat& Cat::operator=(const Cat &other) {
	if (this != &other) {
		this->type = other.type;
	}
	return (*this);
}

Cat::~Cat() {
	std::cout << "Cat die" << std::endl;
}

void Cat::makeSound() const {
	std::cout << "Miaou" << std::endl;
}
