#include "Intern.hpp"

Intern::Intern() {}

Intern::~Intern() {}

Intern::Intern(const Intern &intern) {
	(void)intern;
}

Intern &Intern::operator=(const Intern &intern) {
	(void)intern;
	return *this;
}

AForm *Intern::makeAForm(const std::string &name, const std::string &target) {
	AForm *form = NULL;
	std::string forms[3] = {"shrubbery creation", "robotomy request", "presidential pardon"};

	int i = 0;
	for (; i < 4; i++)
		if (forms[i] == name)
			break;
	switch (i) {
		case 0:
			form = new ShrubberyCreationAForm(target);
			break;
		case 1:
			form = new RobotomyRequestAForm(target);
			break;
		case 2:
			form = new PresidentialPardonAForm(target);
			break;
		default:
			std::cout << "Error creation form" << std::endl;
			return NULL;
	}
	return form;
}
