#include "Bureaucrat.hpp"
#include "AForm.hpp"
#include "ShrubberyCreationForm.hpp"
#include "RobotomyRequestForm.hpp"
#include "PresidentialPardonForm.hpp"
#include "Intern.hpp"

int	main() {

	Bureaucrat tyty("tyty", 5);
	Bureaucrat titi("titi", 45);

	std::cout << "\n---Test0---\n" << std::endl;

		try {
			Intern cho;
			AForm *formShrub;
			AForm *formRoboto;
			AForm *formPresi;

			formShrub = cho.makeAForm("shrubbery creation", "fifi");
			formRoboto = cho.makeAForm("robotomy request", "fifi");
			formPresi = cho.makeAForm("presidential pardon", "fifi");

			titi.signAForm(*formShrub);
			titi.signAForm(*formRoboto);
			titi.signAForm(*formPresi);
			tyty.signAForm(*formPresi);

			titi.executeAForm(*formShrub);
			titi.executeAForm(*formRoboto);
			titi.executeAForm(*formPresi);
			tyty.executeAForm(*formPresi);

			delete formShrub;
			delete formRoboto;
			delete formPresi;
		}
		catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}

	std::cout << "\n---End Test---\n" << std::endl;
}
