#include "Serializer.hpp"

int	main(void) {

	std::cout << "\n---Test0---\n" << std::endl;

	{
		Data struct1;
		Data struct2;

		struct1.isOk = false;
		struct2.isOk = true;
		std::cout << "struct1.isOk: " << std::boolalpha << struct1.isOk << std::endl;
		std::cout << "struct2.isOk: " << std::boolalpha << struct2.isOk << std::endl;

		struct1.value = 5;
		struct2.value = 37;
		std::cout << "struct1.value: " << struct1.value << std::endl;
		std::cout << "struct2.value: " << struct2.value << std::endl;

		std::cout<< "\n";

		uintptr_t tmp1 = Serializer::serialize(&struct1);
		uintptr_t tmp2 = Serializer::serialize(&struct2);

		std::cout << "uintptr_t tmp1: " << tmp1 << std::endl;
		std::cout << "uintptr_t tmp2: " << tmp2 << std::endl;

		std::cout<< "\n";

		Data newstruct1 = *Serializer::deserialize(tmp1);
		Data newstruct2 = *Serializer::deserialize(tmp2);
		std::cout << "newstruct1.isOk: " << std::boolalpha << newstruct1.isOk << std::endl;
		std::cout << "newstruct2.isOk: " << std::boolalpha << newstruct2.isOk << std::endl;
		std::cout << "newstruct1.value: " << newstruct1.value << std::endl;
		std::cout << "newstruct2.value: " << newstruct2.value << std::endl;
	}

	std::cout << "\n---EndTest---\n" << std::endl;
}
