#pragma once

#include <iostream>
#include <fstream>
#include <map>
#include <cstdlib>
#include <sstream>
#include <iomanip>

class BitcoinExchange {
	public:
		BitcoinExchange();
		~BitcoinExchange();
		BitcoinExchange(const BitcoinExchange &bit);
		BitcoinExchange &operator=(const BitcoinExchange &bit);

		void read(const std::string &file);
	private:
		std::map<std::string, double> mapBitcoin;

		void printBitcoinValue(std::string date, double value);
};
